commit 99d0bd2b810d7d4268c104d0a0ea8e67a63b55d2
Author: Moritz Bunkus <m.bunkus@linet.de>
Date:   Wed Feb 8 14:59:32 2017 +0100

    Presenter: mehr Funktionen von L in Tag-Presenter verschieben

diff --git a/SL/Presenter/Tag.pm b/SL/Presenter/Tag.pm
index 0c2dff2d4..770fa1c42 100644
--- a/SL/Presenter/Tag.pm
+++ b/SL/Presenter/Tag.pm
@@ -7,7 +7,7 @@ use SL::HTML::Restrict;
 use parent qw(Exporter);
 
 use Exporter qw(import);
-our @EXPORT = qw(html_tag input_tag hidden_tag javascript man_days_tag name_to_id select_tag checkbox_tag button_tag submit_tag ajax_submit_tag stringify_attributes restricted_html);
+our @EXPORT = qw(html_tag input_tag hidden_tag javascript man_days_tag name_to_id select_tag checkbox_tag button_tag submit_tag ajax_submit_tag stringify_attributes restricted_html link);
 
 use Carp;
 
@@ -282,6 +282,14 @@ sub restricted_html {
   return $html_restricter->process($value);
 }
 
+sub link {
+  my ($self, $href, $content, %params) = @_;
+
+  $href ||= '#';
+
+  return $self->html_tag('a', $content, %params, href => $href);
+}
+
 1;
 __END__
 
@@ -417,6 +425,26 @@ makes it possible to write statements like e.g.
 The attribute C<size> can be used to set the text input's size. It
 defaults to 5.
 
+=item C<hidden_tag $name, $value, %attributes>
+
+Creates a HTML 'input type=hidden' tag named C<$name> with the value
+C<$value> and with arbitrary HTML attributes from C<%attributes>. The
+tag's C<id> defaults to C<name_to_id($name)>.
+
+=item C<checkbox_tag $name, %attributes>
+
+Creates a HTML 'input type=checkbox' tag named C<$name> with arbitrary
+HTML attributes from C<%attributes>. The tag's C<id> defaults to
+C<name_to_id($name)>. The tag's C<value> defaults to C<1>.
+
+If C<%attributes> contains a key C<label> then a HTML 'label' tag is
+created with said C<label>. No attribute named C<label> is created in
+that case.
+
+If C<%attributes> contains a key C<checkall> then the value is taken as a
+JQuery selector and clicking this checkbox will also toggle all checkboxes
+matching the selector.
+
 =item C<select_tag $name, \@collection, %attributes>
 
 Creates an HTML 'select' tag named C<$name> with the contents of one
diff --git a/SL/Template/Plugin/L.pm b/SL/Template/Plugin/L.pm
index bf6c9d5c8..0b0c760ec 100644
--- a/SL/Template/Plugin/L.pm
+++ b/SL/Template/Plugin/L.pm
@@ -76,6 +76,7 @@ sub project_picker           { return _call_presenter('project_picker',
 sub button_tag               { return _call_presenter('button_tag',               @_); }
 sub submit_tag               { return _call_presenter('submit_tag',               @_); }
 sub ajax_submit_tag          { return _call_presenter('ajax_submit_tag',          @_); }
+sub link                     { return _call_presenter('link',                     @_); }
 
 sub _set_id_attribute {
   my ($attributes, $name, $unique) = @_;
@@ -138,14 +139,6 @@ sub li_tag {
   return $self->html_tag('li', $content, @slurp);
 }
 
-sub link {
-  my ($self, $href, $content, %params) = _hashify(3, @_);
-
-  $href ||= '#';
-
-  return $self->html_tag('a', $content, %params, href => $href);
-}
-
 sub yes_no_tag {
   my ($self, $name, $value, %attributes) = _hashify(3, @_);
 
@@ -479,8 +472,14 @@ The following functions are just forwarded to L<SL::Presenter::Tag>:
 
 =item * C<input_tag $name, $value, %attributes>
 
+=item * C<hidden_tag $name, $value, %attributes>
+
+=item * C<checkbox_tag $name, %attributes>
+
 =item * C<select_tag $name, \@collection, %attributes>
 
+=item * C<link $href, $content, %attributes>
+
 =back
 
 Available high-level functions implemented in this module:
@@ -494,32 +493,12 @@ calling L<select_tag>. C<$value> determines
 which entry is selected. The C<%attributes> are passed through to
 L<select_tag>.
 
-=item C<hidden_tag $name, $value, %attributes>
-
-Creates a HTML 'input type=hidden' tag named C<$name> with the value
-C<$value> and with arbitrary HTML attributes from C<%attributes>. The
-tag's C<id> defaults to C<name_to_id($name)>.
-
 =item C<textarea_tag $name, $value, %attributes>
 
 Creates a HTML 'textarea' tag named C<$name> with the content
 C<$value> and with arbitrary HTML attributes from C<%attributes>. The
 tag's C<id> defaults to C<name_to_id($name)>.
 
-=item C<checkbox_tag $name, %attributes>
-
-Creates a HTML 'input type=checkbox' tag named C<$name> with arbitrary
-HTML attributes from C<%attributes>. The tag's C<id> defaults to
-C<name_to_id($name)>. The tag's C<value> defaults to C<1>.
-
-If C<%attributes> contains a key C<label> then a HTML 'label' tag is
-created with said C<label>. No attribute named C<label> is created in
-that case.
-
-If C<%attributes> contains a key C<checkall> then the value is taken as a
-JQuery selector and clicking this checkbox will also toggle all checkboxes
-matching the selector.
-
 =item C<date_tag $name, $value, %attributes>
 
 Creates a date input field, with an attached javascript that will open a