commit a5de1c0190c3ddec059d884e5c64479673030b76
Author: Werner Hahn <wh@futureworldsearch.net>
Date:   Fri Oct 21 11:02:50 2016 +0200

    Shopmodul: Übersetzungen

diff --git a/js/locale/de.js b/js/locale/de.js
index 2fffd6fbf..746938389 100644
--- a/js/locale/de.js
+++ b/js/locale/de.js
@@ -56,6 +56,7 @@ namespace("kivi").setupLocale({
 "Edit text block":"Textblock bearbeiten",
 "Enter longdescription":"Langtext eingeben",
 "Error: Name missing":"Fehler: Name fehlt",
+"File upload":"Dateiupload",
 "Function block actions":"Funktionsblockaktionen",
 "Generate and print sales delivery orders":"Erzeuge und drucke Lieferscheine",
 "Hide all details":"Alle Details verbergen",
@@ -99,15 +100,21 @@ namespace("kivi").setupLocale({
 "Set all source and memo fields":"Alle Beleg-/Memo-Felder setzen",
 "Show all details":"Alle Details anzeigen",
 "Show details":"Details anzeigen",
+"Status Shoptransfer":"Status Shoptransfer",
+"Status Shopupload":"Status Shopupload",
 "Subject":"Betreff",
 "Text block actions":"Textblockaktionen",
 "Text block picture actions":"Aktionen für Textblockbilder",
 "The action can only be executed once.":"Die Aktion kann nur einmal ausgeführt werden.",
+"The IBAN is missing.":"Die IBAN fehlt.",
+"The IBAN is missing.":"Die IBAN fehlt.",
+"The URL is missing.":"URL fehlt",
 "The description is missing.":"Die Beschreibung fehlt.",
 "The field '#{title}' must be set.":"Das Feld »#{title}« muss gesetzt sein.",
 "The name is missing.":"Der Name fehlt.",
 "The name must only consist of letters, numbers and underscores and start with a letter.":"Der Name darf nur aus Buchstaben (keine Umlaute), Ziffern und Unterstrichen bestehen und muss mit einem Buchstaben beginnen.",
 "The option field is empty.":"Das Optionsfeld ist leer.",
+"The port is missing.":"Port fehlt",
 "The recipient, subject or body is missing.":"Der Empfäger, der Betreff oder der Text ist leer.",
 "The selected database is still configured for client \"#1\". If you delete the database that client will stop working until you re-configure it. Do you still want to delete the database?":"Die auswählte Datenbank ist noch für Mandant \"#1\" konfiguriert. Wenn Sie die Datenbank löschen, wird der Mandanten nicht mehr funktionieren, bis er anders konfiguriert wurde. Wollen Sie die Datenbank trotzdem löschen?",
 "The transfer has been canceled by the user.":"Der Vorgang wurde durch den Benutzer abgebrochen.",
diff --git a/locale/de/all b/locale/de/all
index 00f5792ad..59788798c 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -145,6 +145,7 @@ $self->{texts} = {
   'Actions'                     => 'Aktionen',
   'Activate kivitendo module'   => 'Modul aktivieren',
   'Active'                      => 'Aktiv',
+  'Active shops:'               => 'Webshops aktiv',
   'Active?'                     => 'Aktiviert?',
   'Add'                         => 'Erfassen',
   'Add AP Transaction'          => 'Kreditorenbuchung',
@@ -198,6 +199,7 @@ $self->{texts} = {
   'Add custom variable'         => 'Benutzerdefinierte Variable erfassen',
   'Add department'              => 'Abteilung hinzufügen',
   'Add empty line (csv_import)' => 'Leere Zeile einfügen',
+  'Add file'                    => 'Datei hinzufügen',
   'Add function block'          => 'Funktionsblock hinzufügen',
   'Add headers from last uploaded file (csv_import)' => 'Spalten aus der hochgeladenen Datei einfügen',
   'Add invoices'                => 'Rechnungen hinzufügen',
@@ -224,6 +226,7 @@ $self->{texts} = {
   'Add requirement spec type'   => 'Pflichtenhefttypen hinzufügen',
   'Add risk level'              => 'Risikograd hinzufügen',
   'Add section'                 => 'Abschnitt hinzufügen',
+  'Add shop'                    => 'Webshop hinzufügen',
   'Add sub function block'      => 'Unterfunktionsblock hinzufügen',
   'Add taxzone'                 => 'Steuerzone hinzufügen',
   'Add text block'              => 'Textblock erfassen',
@@ -243,6 +246,7 @@ $self->{texts} = {
   'Aktion'                      => 'Aktion',
   'All'                         => 'Alle',
   'All Accounts'                => 'Alle Konten',
+  'All Data'                    => 'Alle Daten',
   'All as list'                 => 'Alle als Liste',
   'All changes in that file have been reverted.' => 'Alle &Auml;nderungen in dieser Datei wurden r&uuml;ckg&auml;ngig gemacht.',
   'All clients'                 => 'Alle Mandanten',
@@ -289,6 +293,7 @@ $self->{texts} = {
   'Application Error. No Format given' => 'Fehler in der Anwendung. Das Ausgabeformat fehlt.',
   'Application Error. Wrong Format' => 'Fehler in der Anwendung. Falsches Format: ',
   'Apply'                       => 'Anwenden',
+  'Apply customer'              => 'Kunde hinzufügen',
   'Apply to all parts'          => 'Bei allen Artikeln setzen',
   'Apply to all transfers'      => 'Bei allen Lagerbewegungen setzen',
   'Apply to parts without booking group' => 'Bei allen Artikeln ohne gültige Buchungsgruppe setzen',
@@ -458,6 +463,7 @@ $self->{texts} = {
   'Booking group (database ID)' => 'Buchungsgruppe (database ID)',
   'Booking group (name)'        => 'Buchungsgruppe (name)',
   'Booking groups'              => 'Buchungsgruppen',
+  'Bookinggroup/Tax'            => 'Buchungsgruppe/Steuer',
   'Books are open'              => 'Die Bücher sind geöffnet.',
   'Books closed up to'          => 'Bücher abgeschlossen bis zum',
   'Boolean variables: If the default value is non-empty then the checkbox will be checked by default and unchecked otherwise.' => 'Ja/Nein-Variablen: Wenn der Standardwert nicht leer ist, so wird die Checkbox standardm&auml;&szlig;ig angehakt.',
@@ -547,7 +553,7 @@ $self->{texts} = {
   'Cash'                        => 'Zahlungsverkehr',
   'Cash accounting'             => 'Ist-Versteuerung',
   'Cash basis accounting'       => 'Einnahmen-Überschuss-Rechnung',
-  'Category'                    => 'Kategorie',
+  'Category'                    => 'Artikelkategorie',
   'Cc'                          => 'Cc',
   'Cc E-mail'                   => 'CC (E-Mail)',
   'Change default bin for this parts' => 'Standardlagerplatz für diese Waren ändern',
@@ -641,6 +647,7 @@ $self->{texts} = {
   'Contrary to Reduced Master Data this will be shown as discount in records.' => 'Im Gegensatz zu Abschlag wird der Rabatt in Belegen ausgewiesen',
   'Conversion of "birthday" contact person attribute' => 'Umstellung des Kontaktpersonenfeldes "Geburtstag"',
   'Conversion to PDF failed: #1' => 'Konvertierung zu PDF schlug fehl: #1',
+  'Converting to deliveryorder' => 'Konvertiere zu Lieferschein',
   'Copies'                      => 'Kopien',
   'Copy'                        => 'Kopieren',
   'Copy address from master data' => 'Adresse aus Stammdaten kopieren',
@@ -719,12 +726,14 @@ $self->{texts} = {
   'Create new templates from master templates' => 'Neue Druckvorlagen aus Vorlagensatz erstellen',
   'Create new version'          => 'Neue Version anlegen',
   'Create one from the context menu by right-clicking on this text.' => 'Erstellen Sie einen aus dem Kontextmenü, indem Sie auf diesen Text rechtsklicken.',
+  'Create order'                => 'Auftrag erstellen',
   'Create tables'               => 'Tabellen anlegen',
   'Created by'                  => 'Erstellt von',
   'Created for'                 => 'Erstellt f&uuml;r',
   'Created on'                  => 'Erstellt am',
   'Creating Documents'          => 'Erzeuge Dokumente',
   'Creating invoices'           => 'Erzeuge Rechnungen',
+  'Creating orders'             => 'erstelle Äufträge',
   'Creating the PDF failed:'    => 'PDF-Erzeugung fehlgeschlagen:',
   'Creation Date'               => 'Erstelldatum',
   'Credit'                      => 'Haben',
@@ -754,6 +763,7 @@ $self->{texts} = {
   'Current / Next Level'        => 'Aktuelles / Nächstes Mahnlevel',
   'Current Earnings'            => 'Gewinn',
   'Current assets account'      => 'Konto für Umlaufvermögen',
+  'Current file'                => 'Aktuelle Datei',
   'Current filter'              => 'Aktueller Filter',
   'Current picture'             => 'Aktuelles Bild',
   'Current profile'             => 'Aktuelles Profil',
@@ -797,6 +807,7 @@ $self->{texts} = {
   'Customer/Vendor Number'      => 'Kunden-/Lieferantennummer',
   'Customer/Vendor/Remote name' => 'Kunden/Lieferantenname laut Bank',
   'Customername'                => 'Kundenname',
+  'Customernumber'              => 'Kundennummer',
   'Customernumberinit'          => 'Kunden-/Lieferantennummernkreis',
   'Customers'                   => 'Kunden',
   'Customers and vendors'       => 'Kunden und Lieferanten',
@@ -903,6 +914,7 @@ $self->{texts} = {
   'Delete profile'              => 'Profil löschen',
   'Delete quotation/order'      => 'Angebot/Auftrag löschen',
   'Delete requirement spec'     => 'Pflichtenheft löschen',
+  'Delete shoporder'            => 'Shopbestellung löschen',
   'Delete template'             => 'Vorlage löschen',
   'Delete text block'           => 'Textblock löschen',
   'Delete transaction'          => 'Buchung löschen',
@@ -1123,6 +1135,7 @@ $self->{texts} = {
   'Edit delivery term'          => 'Lieferbedingungen bearbeiten',
   'Edit department'             => 'Abteilung bearbeiten',
   'Edit file'                   => 'Datei bearbeiten',
+  'Edit fileproperties'         => 'Dateieigenschaften bearbeiten',
   'Edit general settings'       => 'Grundeinstellungen bearbeiten',
   'Edit greetings'              => 'Anreden bearbeiten',
   'Edit language'               => 'Sprache bearbeiten',
@@ -1151,6 +1164,7 @@ $self->{texts} = {
   'Edit sales letters'          => 'Verkaufsbrief erstellen',
   'Edit sales price rule'       => 'Verkaufspreisregel bearbeiten',
   'Edit section #1'             => 'Abschnitt #1 bearbeiten',
+  'Edit shop'                   => 'Shopeigenschaften bearbeiten',
   'Edit taxzone'                => 'Steuerzone bearbeiten',
   'Edit templates'              => 'Vorlagen bearbeiten',
   'Edit text block'             => 'Textblock bearbeiten',
@@ -1349,6 +1363,7 @@ $self->{texts} = {
   'Financial overview for #1'   => 'Finanzübersicht für #1',
   'Finish'                      => 'Abschlie&szlig;en',
   'First 20 Lines'              => 'Nur erste 20 Datensätze',
+  'Firstname'                   => 'Vorname',
   'Fix transaction'             => 'Buchung korrigieren',
   'Fix transactions'            => 'Buchungen korrigieren',
   'Focus position after update' => 'Eingabe-Fokus-Position nach Erneuern',
@@ -1391,6 +1406,7 @@ $self->{texts} = {
   'From this version on it is necessary to name a default value.' => 'Ab dieser Version benötigt kivitendo eine Standardwährung.',
   'From this version on the partnumber of services, articles and assemblies have to be unique.' => 'Ab dieser Version müssen Artikelnummern eindeutig vergeben werden.',
   'From this version on the taxkey 0 must have a tax rate of 0 (for DATEV compatibility).' => 'Ab dieser Version muss der Steuerschlüssel 0 einen Steuersatz von 0% haben (auf Grund der DATEV-Kompatibilität).',
+  'Front page'                  => 'Hauptseite',
   'Full Access'                 => 'Vollzugriff',
   'Full Preview'                => 'Alles',
   'Full access to all functions' => 'Vollzugriff auf alle Funktionen',
@@ -1556,6 +1572,7 @@ $self->{texts} = {
   'Incorrect username or password or no access to selected client!' => 'Ungültiger Benutzername oder Passwort oder kein Zugriff auf den ausgewählten Mandanten!',
   'Increase'                    => 'Erhöhen',
   'Individual Items'            => 'Einzelteile',
+  'Info'                        => 'Info',
   'Information'                 => 'Information',
   'Initial version.'            => 'Initiale Version.',
   'Insert'                      => 'Einfügen',
@@ -1674,11 +1691,13 @@ $self->{texts} = {
   'Last modification'           => 'Letzte Änderung',
   'Last opening balance or all transactions' => 'Letzte Eröffnungsbuchung oder alle Buchungen',
   'Last opening balance or start of year' => 'Letzte Eröffnungsbuchung oder Jahresanfang',
+  'Last ordernumber'            => 'letzte Bestellnummer',
   'Last row, description'       => 'Letzte Zeile, Artikelbeschreibung',
   'Last row, partnumber'        => 'Letzte Zeile, Nummer',
   'Last row, qty'               => 'Letzte Zeile, Menge',
   'Last run at'                 => 'Letzte Ausführung um',
   'Last transaction'            => 'Letzte Buchung',
+  'Last update'                 => 'letzter Upload',
   'Lastcost'                    => 'Einkaufspreis',
   'Lastcost (with X being a number)' => 'Einkaufspreis (X ist eine fortlaufende Zahl)',
   'Left'                        => 'Links',
@@ -1786,6 +1805,9 @@ $self->{texts} = {
   'Merchandise'                 => 'Handelsware',
   'Merchandise (typeabbreviation)' => 'H',
   'Message'                     => 'Nachricht',
+  'Meta tag description'        => 'Metatag Beschreibung',
+  'Meta tag keywords'           => 'Metatag Keywords',
+  'Meta tag title'              => 'Metatag Titel',
   'Method'                      => 'Verfahren',
   'Microfiche'                  => 'Mikrofilm',
   'Minimum Amount'              => 'Mindestbetrag',
@@ -1862,6 +1884,8 @@ $self->{texts} = {
   'No Customer was found matching the search parameters.' => 'Zu dem Suchbegriff wurde kein Endkunde gefunden',
   'No GL template was found.'   => 'Keine Dialogbuchungsvorlage gefunden.',
   'No Journal'                  => 'Kein Journal',
+  'No Shopdescription'          => 'Keine Shop-Artikelbeschreibung',
+  'No Shopimages'               => 'Keine Shop-Bilder',
   'No Vendor was found matching the search parameters.' => 'Zu dem Suchbegriff wurde kein Händler gefunden',
   'No action defined.'          => 'Keine Aktion definiert.',
   'No article has been selected yet.' => 'Es wurde noch kein Artikel ausgewählt.',
@@ -1886,6 +1910,7 @@ $self->{texts} = {
   'No entries have been imported yet.' => 'Es wurden noch keine Einträge importiert.',
   'No entries have been selected.' => 'Es wurden keine Einträge ausgewählt.',
   'No errors have occurred.'    => 'Es sind keine Fehler aufgetreten.',
+  'No file has been uploaded'   => 'Keine Datei hochgeladen',
   'No file has been uploaded yet.' => 'Es wurde noch keine Datei hochgeladen.',
   'No file selected, please set one checkbox!' => 'Kein Element selektiert,bitte eine Box anklicken',
   'No file uploaded yet'        => 'Keine Datei hochgeladen',
@@ -1974,6 +1999,7 @@ $self->{texts} = {
   'Number of invoices to create' => 'Anzahl zu erstellender Rechnungen',
   'Number of months'            => 'Anzahl Monate',
   'Number of new bins'          => 'Anzahl neuer Lagerpl&auml;tze',
+  'Number of orders created:'   => 'Anzahl Aufträge erstellt',
   'Number pages'                => 'Seiten nummerieren',
   'Number variables: \'PRECISION=n\' forces numbers to be shown with exactly n decimal places.' => 'Zahlenvariablen: Mit \'PRECISION=n\' erzwingt man, dass Zahlen mit n Nachkommastellen formatiert werden.',
   'OB Transaction'              => 'EB-Buchung',
@@ -1994,6 +2020,8 @@ $self->{texts} = {
   'One of the columns "qty" or "target_qty" must be given. If "target_qty" is given, the quantity to transfer for each transfer will be calculate, so that the quantity for this part, warehouse and bin will result in the given "target_qty" after each transfer.' => 'Eine der Spalten "qty" oder "target_qty" muss angegeben werden. Wird "target_qty" angegeben, so wird die zu bewegende Menge für jede Lagerbewegung so berechnet, dass die Lagermenge für diesen Artikel, Lager und Lagerplatz nach jeder Lagerbewegung der angegebenen Zielmenge entspricht.',
   'One or more Perl modules missing' => 'Ein oder mehr Perl-Module fehlen',
   'Onhand only sets the quantity in master data, not in inventory. This is only a legacy info field and will be overwritten as soon as a inventory transfer happens.' => 'Das Import-Feld Auf Lager setzt nur die Menge in den Stammdaten, nicht im Lagerbereich. Dies ist historisch gewachsen nur ein Informationsfeld was mit dem tatsächlichen Wert überschrieben wird, sobald eine wirkliche Lagerbewegung stattfindet (DB-Trigger).',
+  'Only Price'                  => 'Nur Preis',
+  'Only Stock'                  => 'Nur Bestand',
   'Only Warnings and Errors'    => 'Nur Warnungen und Fehler',
   'Only applies if the previous is set to true. When filling up unlinked positions, consider them matches if ALL of these fields match. For example, in a business with variants that are defined by a special description, description needs to be part of the identity. If delivering several similar order positions by delivery date is common, reqdate should be included in the identity. Serialnumber is useful when the serialnumber in the order and delivery order has to match.' => 'Ist nur relevant, wenn die vorherige Option angeschaltet ist. Zugewiesene Zeilen müssen in diesen Feldern identisch sein, und werden ansonsten als unterschiedlich behandelt. Wenn ein betried mit Varianten arbeitet, die in der Beschreibung kodiert sind, muss diese mit abgeglichen werden. Wenn Positionen mit Lieferdaten versehen werden, sollten diese mit abgeglichen werden. Seriennummer abzugleichen funktioniert nur, wenn diese in Auftrag und Lieferschein gepflegt werden.',
   'Only booked accounts'        => 'Nur bebuchte Konten',
@@ -2031,9 +2059,12 @@ $self->{texts} = {
   'Order/Item row name'         => 'Name der Auftrag-/Positions-Zeilen',
   'OrderItem'                   => 'Position',
   'Ordered'                     => 'Von Kunden bestellt',
+  'Orderlock'                   => 'Auftragssperre',
   'Orders'                      => 'Aufträge',
   'Orders / Delivery Orders deleteable' => 'Aufträge / Lieferscheine löschbar',
+  'Orders to fetch'             => 'Anzahl Bestellungen holen',
   'Orientation'                 => 'Seitenformat',
+  'Orig. Size w/h'              => 'Orig. Größe b/h',
   'Orphaned'                    => 'Nie benutzt',
   'Orphaned currencies'         => 'Verwaiste Währungen',
   'Other Matches'               => 'Andere Treffer',
@@ -2087,6 +2118,7 @@ $self->{texts} = {
   'Part picker'                 => 'Artikelauswahl',
   'PartClassAbbreviation'       => 'Abkürzung der Artikel-Klassifizierung',
   'Part_br_Description'         => 'Beschreibung',
+  'Partdescriptipion'           => 'Beschreibung',
   'Partial invoices'            => 'Teilrechnungen',
   'Partnumber'                  => 'Artikelnummer',
   'Parts'                       => 'Waren',
@@ -2186,7 +2218,9 @@ $self->{texts} = {
   'Port'                        => 'Port',
   'Portrait'                    => 'Hochformat',
   'Position identity fields for fill up?' => 'Felder, die für Abgleich übereinstimmen müssen?',
+  'Position'                    => 'Position',
   'Position type in quotation/order' => 'Positionstyp in Angebot/Auftrag',
+  'Positions'                   => 'Positionen',
   'Post'                        => 'Buchen',
   'Post Payment'                => 'Zahlung buchen',
   'Post payments'               => 'Zahlungen buchen',
@@ -2225,6 +2259,7 @@ $self->{texts} = {
   'Price Source'                => 'Preisquelle',
   'Price Sources to be disabled in this client' => 'Preisquellen die in diesem Mandanten deaktiviert werden sollen',
   'Price Types'                 => 'Preistypen',
+  'Price and Stock'             => 'Preis und Bestand',
   'Price factor (database ID)'  => 'Preisfaktor (Datenbank-ID)',
   'Price factor (name)'         => 'Preisfaktor (Name)',
   'Price group'                 => 'Preisgruppe',
@@ -2234,7 +2269,9 @@ $self->{texts} = {
   'Price information'           => 'Preisinformation',
   'Price or discount must not be zero.' => 'Preis/Rabatt darf nicht 0,00 sein',
   'Price rules must have at least one rule.' => 'Preisregeln brauchen mindestens eine Bedingung.',
+  'Price source'                => 'Preisquelle',
   'Price sources deactivated in this client' => 'Preisquellen die in diesem Mandanten deaktiviert sind',
+  'Price type'                  => 'Preistyp',
   'Price type explanation'      => 'Preistyp Erklärung',
   'Pricegroup'                  => 'Preisgruppe',
   'Pricegroups'                 => 'Preisgruppen',
@@ -2663,10 +2700,39 @@ $self->{texts} = {
   'Shipping Point'              => 'Versandort',
   'Shipping address (name)'     => 'Name der Lieferadresse',
   'Shipping date'               => 'Lieferdatum',
+  'Shippingcosts'               => 'Versandkosten',
   'Shipto'                      => 'Lieferanschriften',
   'Shipto deleted.'             => 'Lieferadresse gelöscht',
   'Shipto is in use and was flagged invalid.' => 'Lieferadresse ist noch in Verwendung, und wurde als ungültig markiert.',
+  'Shop'                        => 'Webshop',
+  'Shop Billing Address'        => 'Shop - Rechnungsadresse',
+  'Shop Customer Address'       => 'Shop - Kundenadresse',
+  'Shop Delivery Address'       => 'Shop - Lieferadresse',
+  'Shop Headdata'               => 'Shop - Stammdaten',
+  'Shop Host'                   => '',
+  'Shop Host/Connector'         => '',
+  'Shop Order'                  => 'Shopauftrag',
+  'Shop Order Date'             => 'Shopauftragsdatum',
+  'Shop Order Number'           => 'Shopauftragsnummer',
+  'Shop OrderIP'                => 'Shop Bestell IP',
+  'Shop Orderamount'            => 'Shop Auftragssumme',
+  'Shop Orderdate'              => 'Shopauftragsdatum',
+  'Shop Ordernotes'             => 'Shop Bemerkungen',
+  'Shop Ordernumber'            => 'Shopauftragsnummer',
+  'Shop Orders'                 => 'Shopaufträge',
   'Shop article'                => 'Shopartikel',
+  'Shop customernumber'         => 'Shop - Kundennumer',
+  'Shop orderdate'              => 'Shopauftragsdatum',
+  'Shop ordernumber'            => 'Shopauftragsnummer',
+  'Shop part'                   => 'Shopartikel',
+  'Shop type'                   => 'Shop Typ',
+  'Shop variables'              => 'Shopvariablen',
+  'ShopOrders'                  => 'Shopbestellungen',
+  'Shopcategories'              => 'Shopartikelgruppen',
+  'Shoporder'                   => 'Shopbestellung',
+  'Shoporder deleted -- '       => 'ungültig',
+  'Shops'                       => 'Webshops',
+  'Shopvariables and Images - valid for all shops' => 'Shopvariablen und Bilder - gültig für alle Shops',
   'Short'                       => 'Knapp',
   'Should ap transactions be and when should they be changeable or deleteable after posting?' => 'Sollen Kreditorenbuchungen nach der Buchung zu ändern oder zu löschen sein?',
   'Should ar transactions be and when should they be changeable or deleteable after posting?' => 'Sollen Debitorenbuchungen nach der Buchung zu ändern oder zu löschen sein?',
@@ -2714,6 +2780,7 @@ $self->{texts} = {
   'Show mappings (csv_import)'  => 'Spaltenzuordnungen anzeigen',
   'Show old dunnings'           => 'Alte Mahnungen anzeigen',
   'Show only marked as paid invoices' => 'Nur "als geschlossen markiert" zeigen',
+  'Show order'                  => 'Bestellung anzeigen',
   'Show overdue sales quotations and requests for quotations...' => 'Überfällige Angebote und Preisanfragen anzeigen...',
   'Show parts'                  => 'Artikel anzeigen',
   'Show parts longdescription (notes) in select list' => 'Langtext in Auswahlliste bei mehreren Treffern im Stammdaten-Bestand anzeigen',
@@ -2754,6 +2821,7 @@ $self->{texts} = {
   'Solution'                    => 'Lösung',
   'Sorry, I am too stupid to figure out the default warehouse/bin and the sold qty. I drop the default warehouse/bin option.' => 'Entschuldigung, ich bin nicht in der Lage Standard-Lager und die Menge in gewählten Belegen gleichzeitig anzuzeigen. Ich lass die Standard-Lager weg.',
   'Sort By'                     => 'Sortiert nach',
+  'Sort order'                  => 'Sortierfolge',
   'Source'                      => 'Beleg',
   'Source BIC'                  => 'Quell-BIC',
   'Source IBAN'                 => 'Quell-IBAN',
@@ -2779,11 +2847,14 @@ $self->{texts} = {
   'Statement sent to'           => 'Gesendet an ',
   'Statements sent to printer!' => 'Sammelrechnungen an Drucker geschickt!',
   'Status'                      => 'Status',
+  'Status Shoptransfer'         => 'Status Shoptransfer',
+  'Status Shopupload'           => 'Status Shopupload',
   'Step 1 -- limit number of delivery orders to process' => 'Schritt 1 -- Anzahl zu verarbeitender Lieferscheine begrenzen',
   'Step 2'                      => 'Schritt 2',
   'Step 2 -- Watch status'      => 'Schritt 2 -- Status beobachten',
   'Steuersatz'                  => 'Steuersatz',
   'Stock'                       => 'Einlagern',
+  'Stock Local/Shop'            => 'Bestand Lokal/Online',
   'Stock Qty for Date'          => 'Lagerbestand am',
   'Stock for part #1'           => 'Bestand für Artikel #1',
   'Stock value'                 => 'Bestandswert',
@@ -2924,6 +2995,7 @@ $self->{texts} = {
   'The PDF has been printed'    => 'Das PDF-Dokument wurde gedruckt.',
   'The SEPA export has been created.' => 'Der SEPA-Export wurde erstellt',
   'The SEPA strings have been saved.' => 'Die bei SEPA-Überweisungen verwendeten Begriffe wurden gespeichert.',
+  'The URL is missing.'         => 'URL fehlt',
   'The WebDAV feature has been used.' => 'Das WebDAV-Feature wurde benutzt.',
   'The abbreviation is missing.' => 'Abkürzung fehlt',
   'The access rights a user has within a client instance is still governed by his group membership.' => 'Welche Zugriffsrechte ein Benutzer innerhalb eines Mandanten hat, wird weiterhin über Gruppenmitgliedschaften geregelt.',
@@ -3145,6 +3217,13 @@ $self->{texts} = {
   'The session has expired. Please log in again.' => 'Die Sitzung ist abgelaufen. Bitte melden Sie sich erneut an.',
   'The session is invalid or has expired.' => 'Sie sind von kivitendo abgemeldet.',
   'The settings were saved, but the password was not changed.' => 'Die Einstellungen wurden gespeichert, aber das Passwort wurde nicht geändert.',
+  'The shop has been created.'  => 'Shop hinzugefügt',
+  'The shop has been deleted.'  => 'Shop gelöscht',
+  'The shop has been saved.'    => 'Shop gespeichert',
+  'The shop has been used and cannot be deleted.' => 'Der Shop ist gebraucht und kann nicht gelöscht werden',
+  'The shop part has been created.' => 'Shopartikel angelegt',
+  'The shop part has been saved.' => 'Shopartikel gespeichert',
+  'The shop part wasn\'t updated.' => 'Shopartikel wurde nicht aktualisiert!',
   'The source warehouse does not contain any bins.' => 'Das Quelllager enth&auml;lt keine Lagerpl&auml;tze.',
   'The start date is missing.'  => 'Das Startdatum fehlt.',
   'The subject is missing.'     => 'Der Betreff fehlt.',
@@ -3325,6 +3404,7 @@ $self->{texts} = {
   'To (time)'                   => 'Bis',
   'To Date'                     => 'Bis',
   'To continue please change the taxkey 0 to another value.' => 'Um fortzufahren, ändern Sie bitte den Steuerschlüssel 0 auf einen anderen Wert.',
+  'To upload images: Please create shoppart first' => 'Um Bilder hochzuladen bitte Shopartikel zuerst anlegen',
   'To user login'               => 'Zum Benutzerlogin',
   'Toggle marker'               => 'Markierung umschalten',
   'Too many results (#1 from #2).' => 'Zu viele Artikel (#1 von #2)',
@@ -3363,6 +3443,7 @@ $self->{texts} = {
   'Transdate is before #1'      => 'Belegdatum ist vor #1',
   'Transdate to'                => 'Kontoauszugsdatum bis',
   'Transfer'                    => 'Umlagern',
+  'Transfer Date'               => 'übernommen am',
   'Transfer Quantity'           => 'Umlagermenge',
   'Transfer To Stock'           => 'Lagereingang',
   'Transfer data to Geierlein ELSTER application' => 'Daten in Geierlein ELSTER-Anwendung übernehmen',
@@ -3377,6 +3458,7 @@ $self->{texts} = {
   'Transfer qty'                => 'Umlagermenge',
   'Transfer services via default' => 'Falls Ein- /Auslagern über Standardlagerplatz aktiviert ist, auch die Dienstleistungen standardmässig Ein- und Auslagern',
   'Transfer successful'         => 'Lagervorgang erfolgreich',
+  'Transferred'                 => 'Übernommen',
   'Translation'                 => 'Übersetzung',
   'Translations'                => 'Übersetzungen',
   'Transport and service costs reminder' => 'Transport- und Versandkosten-Erinnerung',
@@ -3430,9 +3512,11 @@ $self->{texts} = {
   'Until'                       => 'Bis',
   'Update'                      => 'Erneuern',
   'Update Discount'             => 'Rabatt übernehmen',
+  'Update Partnumber'           => '',
   'Update Price'                => 'Preis übernehmen',
   'Update Prices'               => 'Preise aktualisieren',
   'Update SKR04: new tax account 3804 (19%)' => 'Update SKR04: neues Steuerkonto 3804 (19%) für innergemeinschaftlichen Erwerb',
+  'Update customer using billing address' => 'Kunde mit Shop-Rechnungsadresse überschreiben',
   'Update prices'               => 'Preise aktualisieren',
   'Update prices of existing entries' => 'Preise von vorhandenen Artikeln aktualisieren',
   'Update prices of existing entries / skip non-existent' => 'Preise von vorhandenen Artikel aktualisieren / Nicht vorhandene überspringen',
@@ -3444,6 +3528,9 @@ $self->{texts} = {
   'Update this draft.'          => 'Aktuellen Entwurf speichern',
   'Update with section'         => 'Mit Abschnitt aktualisieren',
   'Updated'                     => 'Erneuert am',
+  'Updated categories'          => 'Artikelgruppe aktualisiert',
+  'Updated part [#1] in shop [#2] at #3' => 'Artikel [#1] in Shop [#2] am [#3] aktualisiert',
+  'Updated shop part'           => 'Artikel aktualisiert',
   'Updating data of existing entry in database' => 'Aktualisierung von vorhandenen Datenbankdaten',
   'Updating existing entry in database' => 'Existierenden Eintrag in Datenbank aktualisieren',
   'Updating items with additional parts' => 'Positionen für zusätzliche Artikel aktualisieren',
@@ -3561,6 +3648,10 @@ $self->{texts} = {
   'WebDAV link'                 => 'WebDAV-Link',
   'WebDAV save documents'       => 'Belege in WebDAV-Ablage speichern',
   'Webserver interface'         => 'Webserverschnittstelle',
+  'Webshop'                     => 'Webshop',
+  'Webshop Import'              => 'Webshop Import',
+  'Webshop articles'            => 'Webshop Artikel',
+  'Webshops articles'           => 'Webshops Artikel',
   'Weight'                      => 'Gewicht',
   'Weight unit'                 => 'Gewichtseinheit',
   'What <b>term</b> you are looking for?' => 'Nach welchem <b>Begriff</b> wollen Sie suchen?',
@@ -3638,6 +3729,7 @@ $self->{texts} = {
   'Your import is being processed.' => 'Ihr Import wird verarbeitet',
   'Zeitraum'                    => 'Zeitraum',
   'Zero amount posting!'        => 'Buchung ohne Wert',
+  'Zip'                         => 'PLZ',
   'Zip, City'                   => 'PLZ, Ort',
   'Zipcode'                     => 'PLZ',
   '[email]'                     => '[email]',
@@ -3670,6 +3762,7 @@ $self->{texts} = {
   'bestbefore #1'               => 'Mindesthaltbarkeit #1',
   'bin_list'                    => 'Lagerliste',
   'bis'                         => 'bis',
+  'brutto'                      => 'brutto',
   'building data'               => 'Verarbeite Daten',
   'building report'             => 'Erstelle Bericht',
   'cash'                        => 'Ist-Versteuerung',
@@ -3796,6 +3889,7 @@ $self->{texts} = {
   'not running'                 => 'läuft nicht',
   'not set'                     => 'nicht gesetzt',
   'not shipped'                 => 'nicht geliefert',
+  'not transferred'             => 'nicht übernommen',
   'not transferred in yet'      => 'noch nicht eingelagert',
   'not transferred out yet'     => 'noch nicht ausgelagert',
   'not yet executed'            => 'Noch nicht ausgeführt',
@@ -3833,12 +3927,14 @@ $self->{texts} = {
   'quarter'                     => 'Vierteljährliche (quartalsweise) Abgabe',
   'quotation_list'              => 'angebotsliste',
   'release_material'            => 'Materialausgabebe',
+  'renew'                       => '',
   'reorder item'                => 'Eintrag umsortieren',
   'repeated execution'          => 'wiederholte Ausführung',
   'report_generator_dispatch_to is not defined.' => 'report_generator_dispatch_to ist nicht definiert.',
   'report_generator_nextsub is not defined.' => 'report_generator_nextsub ist nicht definiert.',
   'request_quotation'           => 'Angebotsanforderung',
   'return_material'             => 'Materialr&uuml;ckgabe',
+  'revert deleted'              => 'löschen rückgängig',
   'rfq_list'                    => 'anfragenliste',
   'running'                     => 'läuft',
   'sales tax identification number' => 'USt-IdNr.',
@@ -3879,10 +3975,12 @@ $self->{texts} = {
   'taxnumber'                   => 'Automatikkonto',
   'terminated'                  => 'gekündigt',
   'time and effort based position' => 'Aufwandsposition',
+  'to'                          => 'bis',
   'to (date)'                   => 'bis',
   'to (set to)'                 => 'auf',
   'to (time)'                   => 'bis',
   'transfer'                    => 'Umlagerung',
+  'transferred'                 => 'übernommen',
   'transferred in'              => 'eingelagert',
   'transferred in / out'        => 'ein- / ausgelagert',
   'transferred out'             => 'ausgelagert',